<template>
  <ContentWrap>
    <!-- 搜索工作栏 -->
    <el-form
      class="-mb-15px"
      :model="queryParams"
      ref="queryFormRef"
      :inline="true"
      label-width="68px"
    >
      <el-form-item :label="t('message.templateName')" prop="name">
        <el-input
          v-model="queryParams.name"
          :placeholder="t('message.pleaseEnterTheTemplateName')"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item>
        <el-button @click="handleQuery"><Icon icon="ep:search" class="mr-5px" /> {{t('common.search')}}</el-button>
        <el-button @click="resetQuery"><Icon icon="ep:refresh" class="mr-5px" /> {{t('common.reset')}}</el-button>
        <el-button
          type="primary"
          plain
          @click="openForm('create')"
          v-hasPermi="['message:wechat-template:create']"
        >
          <Icon icon="ep:plus" class="mr-5px" /> {{t('action.add')}}
        </el-button>
        <!-- <el-button
          type="success"
          plain
          @click="handleExport"
          :loading="exportLoading"
          v-hasPermi="['message:wechat-template:export']"
        >
          <Icon icon="ep:download" class="mr-5px" /> {{t('action.export')}}
        </el-button> -->
      </el-form-item>
    </el-form>
  </ContentWrap>

  <!-- 列表 -->
  <ContentWrap>
    <el-table v-loading="loading" :data="list">
      <el-table-column label="ID" align="center" prop="id" />
      <el-table-column :label="t('message.templateNumber')" align="center" prop="tempkey" />
      <el-table-column :label="t('message.templateName')" align="center" prop="name" />
      <el-table-column :label="t('message.templateId')" align="center" prop="tempid" />
      <el-table-column :label="t('message.type')" align="center" prop="type">
        <template #default="scope">
           <span v-if="scope.row.type=='template'">{{t('message.templateMessage')}}</span>
           <span v-if="scope.row.type=='subscribe'">{{t('message.subscribeMessage')}}</span>
           <span v-else></span>
        </template>
      </el-table-column>
      <el-table-column
        :label="t('public.addTime')"
        align="center"
        prop="createTime"
        :formatter="dateFormatter"
      />
      <el-table-column :label="t('public.operate')" align="center">
        <template #default="scope">
          <el-button
            link
            type="primary"
            @click="openForm('update', scope.row.id)"
            v-hasPermi="['message:wechat-template:update']"
          >
          {{t('action.edit')}}
          </el-button>
          <el-button
            link
            type="danger"
            @click="handleDelete(scope.row.id)"
            v-hasPermi="['message:wechat-template:delete']"
          >
          {{ t('public.delete') }}
          </el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页 -->
    <Pagination
      :total="total"
      v-model:page="queryParams.pageNo"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />
  </ContentWrap>

  <!-- 表单弹窗：添加/修改 -->
  <WechatTemplateForm ref="formRef" @success="getList" />
</template>

<script setup lang="ts" name="WechatTemplate">
import { dateFormatter } from '@/utils/formatTime'
import download from '@/utils/download'
import * as WechatTemplateApi from '@/api/message/wechatTemplate'
import WechatTemplateForm from './WechatTemplateForm.vue'
const message = useMessage() // 消息弹窗
const { t } = useI18n() // 国际化

const loading = ref(true) // 列表的加载中
const total = ref(0) // 列表的总页数
const list = ref([]) // 列表的数据
const queryParams = reactive({
  pageNo: 1,
  pageSize: 10,
  tempkey: null,
  name: null,
  content: null,
  tempid: null,
  createTime: [],
  status: null,
  type: null
})
const queryFormRef = ref() // 搜索的表单
const exportLoading = ref(false) // 导出的加载中

/** 查询列表 */
const getList = async () => {
  loading.value = true
  try {
    const data = await WechatTemplateApi.getWechatTemplatePage(queryParams)
    list.value = data.list
    total.value = data.total
  } finally {
    loading.value = false
  }
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.pageNo = 1
  getList()
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value.resetFields()
  handleQuery()
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (type: string, id?: number) => {
  formRef.value.open(type, id)
}

/** 删除按钮操作 */
const handleDelete = async (id: number) => {
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await WechatTemplateApi.deleteWechatTemplate(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {}
}

/** 导出按钮操作 */
const handleExport = async () => {
  try {
    // 导出的二次确认
    await message.exportConfirm()
    // 发起导出
    exportLoading.value = true
    const data = await WechatTemplateApi.exportWechatTemplate(queryParams)
    download.excel(data, t('message.weChatTemplateXls'))
  } catch {
  } finally {
    exportLoading.value = false
  }
}

/** 初始化 **/
onMounted(() => {
  getList()
})
</script>
